%Slavery Robustness Random Effects Models

%%
%DATA Organizing & Cleaning

%Create new ordered pair_id's
    pair_id_new = zeros(size(ID,1)/2,1);
    for i=1:size(ID,1)/2
        pair_id_new(i)=i;
    end
        
    pair_id_new = [pair_id_new; pair_id_new];
    pair_id_new = sort(pair_id_new,1);          %This vector has new pair_id lables
        

    %Find observations with missing values
    missing = zeros(size(DATA,1),1);
    for i=1:size(DATA,1)
        for j=1:size(DATA,2)
            if isnan(DATA(i,j))== 1
                missing(i,1) = 1;               %missing contains info of observations with missings
            end
         
        end
       
    end

    
    %Produce info of pairs of observations with missings to also drop
    drop_codes = pair_id_new(missing==1);       %drop_codes is vector of pair codes to drop
    
    
    %Create vector of observations to drop
 
    drop = zeros(size(pair_id_new,1),1);
    for i=1:size(drop_codes,1)
        for j=1:size(pair_id_new,1)
            if drop_codes(i,1)==pair_id_new(j,1)
                drop(j,1)=1;                    %drop contains info of observations to drop
            end
         
        end
        
    end
       
    %Drop observations
    ID = ID(drop==0,:);                         %drop observations
    DATA = DATA(drop==0,:);        
            
   %Now ID and DATA contain all the observations for estimation
   
   %Create the new pair_id's again, after having droped observations
   
    pair_id_new = zeros(size(ID,1)/2,1);
    for i=1:size(ID,1)/2
        pair_id_new(i)=i;
       
    end
        
    pair_id_new = [pair_id_new; pair_id_new];
    pair_id_new = sort(pair_id_new,1);          %This vector has new pair_id lables      
            
    %Cleaning 
    clear i j missing drop_codes drop
    
    
    %Create variables for estimation

    code = ID(:,1);
    pair_id = pair_id_new;
    CLUSTER_DUMMIES = ID(:,4:45);
    drop_cl = sum(CLUSTER_DUMMIES);
    CLUSTER_DUMMIES = CLUSTER_DUMMIES(:,drop_cl~=0);
    cluster_id = sum((CLUSTER_DUMMIES*diag(1:1:size(CLUSTER_DUMMIES,2)))')';
    PAIR_DUMMIES = ID(:,46:251);
    DEPT_DUMMIES = ID(:,252:283);
    unique = ID(:,284);
    
    
    %Exclude dummies that are all zero
    clean = sum(CLUSTER_DUMMIES);
    CLUSTER_DUMMIES = CLUSTER_DUMMIES(:,clean~=0);
    
    clean = sum(PAIR_DUMMIES);
    PAIR_DUMMIES = PAIR_DUMMIES(:,clean~=0);
    
    clean = sum(DEPT_DUMMIES);
    DEPT_DUMMIES = DEPT_DUMMIES(:,clean~=0);
    
    Y = DATA(:,1);                                                                                               %Outcome variable
    S = DATA(:,2:4);                                                                                             %Slavery data col 1= intensity, col 2=dummy, col 3=capped at 10%  
    G = DATA(:,5);                                                                                               %Gold mine dummy (instrument)
    COVARIATES_LINEAR = [DATA(:,6) DATA(:,10) DATA(:,14) DATA(:,18) DATA(:,22) DATA(:,26) DATA(:,30:33)];        %Linear Controls
    COVARIATES_POLY = DATA(:,6:33);                                                                              %Polynomial controls
    ETHNIC = DATA(:,34:36);                                                                                      %Ethnic distribution 
    COLONIAL_STATE = DATA(:,37:38);                                                                              %Colonial State data col 1=indicedyd, col 2 = tot_func_dyd
    ROADS = DATA(:,39:40);                                                                                       %Road Density data
    MALARIA = DATA(:,41);                                                                                        %Malaria Incidence
    
    obs = size(Y,1);                                                                                             %Number of observations
    num_clusters = size(CLUSTER_DUMMIES,2);                                                                      %Number of clusters
    num_pairs = size(PAIR_DUMMIES,2);                                                                            %Number of neighbor pairs
    num_depts = size(DEPT_DUMMIES,2);                                                                            %Number of departments
    num_pairs_per_cluster = (G'*CLUSTER_DUMMIES)';                                                               %Number of pairs in each cluster
    gold_codes = [((((code.*G)'*CLUSTER_DUMMIES))./num_pairs_per_cluster')' [1:1:num_clusters]'];                %Codes of Gold mine municipalities, and their cluster

    R = [code CLUSTER_DUMMIES];                                                                                                                                                                                                                                                                                                          
    R = R(G==0,:);
    R = sortrows(R);
    [non_gold_codes(:,1) non_gold_codes(:,2)] = count_unique(R(:,1));                                            %Codes of Non Gold mine municipalities, and the number of clusters they belong to
    
    A = R';
    AA = [1:1:size(CLUSTER_DUMMIES,2)]';
    
   
    %AAA = zeros();
    for i=1:size(A,2)
        AAA(:,i) = A(2:size(A,1),i).*AA;
       
    end
    
    non_gold_cluster_codes = [A(1,:); AAA]; 
    non_gold_cluster_codes = sortrows([non_gold_cluster_codes(1,:); sum(non_gold_cluster_codes) - non_gold_cluster_codes(1,:)]');         %List of codes of non gold mine municipalities and the clusters they belong to
    
    clear clean A AA AAA
%%            
    %RANDOM EFFECTS NO CORRELATION
        
        %Build backbone of OMEGA
        
        obs_short = sum(unique);                                            %Size of sample
        obs_NG_short = obs_short - num_clusters;                            %Number of non-gold mine municipalities 
        obs_G_short = num_clusters;                                         %Number of gold mine municipalities
        sum_mk = sum(non_gold_codes(:,2));                                  %Number of pairs = sum of number of clusters in which each non-gold-mine municipality is
        CLUSTER_DUMMIES_short = CLUSTER_DUMMIES(unique==1,:);               %Matrix of cluster dummies for unique sample
           
        XI = zeros(obs_short, obs_short);                                   %Matrix to indicate number and position of sigma_xi_2's in OMEGA
        NU = diag(ones(obs_short,1));                                       %Matrix to indicate number and position of sigma_nu_2's in OMEGA
        
        G_short = G(unique==1,:);
        code_short = code(unique==1,:);
        
        T = [gold_codes; non_gold_cluster_codes];
          
        i=1;
        j=1; 
        for i=1:obs_short
            for j=1:obs_short
                g1 = T(:,2).*ismember(T(:,1), code_short(i));
                g1 = g1(g1~=0);
                
                g2 = T(:,2).*ismember(T(:,1), code_short(j));
                g2 = g2(g2~=0);
                
                common = intersect(g1,g2);
                
                if isempty(common)==1
                    XI(i,j) = 0;
                else
                    XI(i,j) = size(common,1);
                end
            end
        end
        
        L = XI+NU;
        
        for i=1:obs_short
            for j=1:obs_short
                if L(i,j)>0
                    L(i,j)=1;
                end
            end
        end
        
        
        %1. RANDOM EFFECTS OLS    
 
            %With Polynomial Geographic Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,1) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,1) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,1)= R_sq;
        
 
             %Ethnic Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ETHNIC];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,3) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,3) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly_ethnic = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly_ethnic;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly_ethnic = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly_ethnic = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly_ethnic));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,3)= R_sq;
                
                
             %Colonial State Index Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,1)];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,5) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,5) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly_indicedyd = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly_indicedyd;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly_indicedyd = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly_indicedyd = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly_indicedyd));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,5)= R_sq;   
                
                
             %Colonial Employees Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,2)];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,7) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,7) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly_funcdyd = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly_funcdyd;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly_funcdyd = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly_funcdyd = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly_funcdyd));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,7)= R_sq;   
                
                
              %Roads Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ROADS];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,9) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,9) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly_roads = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly_roads;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly_roads = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly_roads = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly_roads));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,9)= R_sq;      
                
                
             %Malaria Controls OLS
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY MALARIA];
           
                X_short = X(unique==1,:);
                Y_short = Y(unique==1,:);
       
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
        
                %Get OLS residuals to construct Feasible OMEGA
                b = (X_short'*X_short)\(X_short'*Y_short);
                eps = Y_short - X_short*b;
        
                e_e = eps*eps';
             
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
        
                sigma_xi2(1,11) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,11) = sigma_nu_2;
        
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
         
        
                %Compute Random Effects Estimator
                betas_RE_OLS_SlaveDummy_poly_malaria = ((X_short'/OMEGA)*X_short)\((X_short'/OMEGA)*Y_short);
              
                u = Y_short - X_short*betas_RE_OLS_SlaveDummy_poly_malaria;
        
                u_u = u*u';
        
                Avar_betas_RE_OLS_SlaveDummy_poly_malaria = (obs_short/(obs_short-size(X_short,2)))*(((X_short'/OMEGA)*X_short)\(X_short'/OMEGA)*(u_u.*L)*(OMEGA\X_short)/((X_short'/OMEGA)*X_short));
                                
                std_betas_RE_OLS_SlaveDummy_poly_malaria = sqrt(diag(Avar_betas_RE_OLS_SlaveDummy_poly_malaria));    
                
                R_sq = 1 - ((sum(u.*u)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
                Rsq(1,11)= R_sq;             
                
                
           
                
                
                
                
            %2. RANDOM EFFECTS IV
                    
            %With Polynomial Geographic Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,2) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,2) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,2)= R_sq;


             %Ethnic Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ETHNIC];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ETHNIC];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,4) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,4) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly_ethnic = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly_ethnic = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly_ethnic;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly_ethnic = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly_ethnic = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly_ethnic));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly_ethnic = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly_ethnic;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly_ethnic = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly_ethnic = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly_ethnic));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,4)= R_sq;


            %Colonial State Index Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,1)];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,1)];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,6) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,6) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly_indicedyd = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly_indicedyd = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly_indicedyd;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly_indicedyd = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly_indicedyd = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly_indicedyd));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly_indicedyd = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly_indicedyd;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly_indicedyd = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly_indicedyd = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly_indicedyd));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,6)= R_sq;


           %Colonial Employees Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,2)];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY COLONIAL_STATE(:,2)];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,8) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,8) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly_funcdyd = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly_funcdyd = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly_funcdyd;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly_funcdyd = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly_funcdyd = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly_funcdyd));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly_funcdyd = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly_funcdyd;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly_funcdyd = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly_funcdyd = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly_funcdyd));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,8)= R_sq;


             %Roads Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ROADS];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY ROADS];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,10) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,10) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly_roads = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly_roads = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly_roads;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly_roads = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly_roads = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly_funcdyd));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly_roads = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly_roads;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly_roads = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly_roads = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly_roads));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,10)= R_sq;



           %Malaria Controls IV
                X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY MALARIA];
                Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) COVARIATES_POLY MALARIA];
    
                X_short = X(unique==1,:);
                Z_short = Z(unique==1,:);
                Y_short = Y(unique==1,:);
        
                clean = sum(X_short);
                X_short = X_short(:,clean~=0);
                clean = sum(Z_short);
                Z_short = Z_short(:,clean~=0);
                Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
                X_hat_short = Pz*X_short;   
        
                %Get OLS residuals to construct Feasible OMEGA (White says can use either IV or OLS residuals)
                b = (X_short'*X_short)\(X_short'*Y_short);
        
                eps = Y_short - X_short*b;
        
                e_e = (eps*eps');
        
                %Compute Estimator of sigma_xi_2
                Q = tril(XI) - diag(diag(XI));
        
                SUM_sigma_xi_2 = sum(e_e(Q==1));
                sigma_xi_2 = ((obs_short)/(obs_short - size(X_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
        
                if sigma_xi_2<0
                    sigma_xi_2=0;
                end
                
                sigma_xi2(1,12) = sigma_xi_2;
        
                %Compute Estimator of sigma_nu_2
                a_hat = sum(diag(e_e));
        
                sigma_nu_2 = (obs_short/(obs_short - size(X_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                sigma_nu2(1,12) = sigma_nu_2;
         
                %Create OMEGA
                OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
        
        
                %Second Stage     
                %betas_RE_IV_SlaveDummy_poly_malaria = ((X_hat_short'/OMEGA)*X_hat_short)\((X_hat_short'/OMEGA)*Y_short);
        
                betas_RE_IV_SlaveDummy_poly_malaria = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short))\((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*Y_short));
                       
                u = Y_short - X_short*betas_RE_IV_SlaveDummy_poly_malaria;
        
                u_u = u*u';
                AV1 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)*X_short));
                AV2 = ((((X_short'/OMEGA)*Z_short)/((Z_short'/OMEGA)*Z_short))*((Z_short'/OMEGA)));
                
                Avar_betas_RE_IV_SlaveDummy_poly_malaria = (obs_short/(obs_short-size(X_short,2)))*(AV1\(AV2*(u_u.*L)*AV2')/AV1);
              
                std_betas_RE_IV_SlaveDummy_poly_malaria = sqrt(diag(Avar_betas_RE_IV_SlaveDummy_poly_funcdyd));  
        
                %First Stage                       
                b = (Z_short'*Z_short)\(Z_short'*X_short(:,2));
                
                    u = X_short(:,2) - Z_short*b;
                    u_u =u*u';
                
                    SUM_sigma_xi_2 = sum(u_u(Q==1));
                    sigma_xi_2 = ((obs_short)/(obs_short - size(Z_short,2)))*(SUM_sigma_xi_2/sum(sum(Q)));
                
                    if sigma_xi_2<0
                        sigma_xi_2=0;
                    end
                
                    a_hat = sum(diag(u_u));
        
                    sigma_nu_2 = (obs_short/(obs_short - size(Z_short,2)))*((1/obs_short)*(a_hat - ((sum_mk + obs_G_short)*(sigma_xi_2/((obs_short)/(obs_short - size(X_short,2)))))));
        
                    OMEGA = sigma_xi_2*XI + sigma_nu_2*NU;
                
                
                    betas_1st_RE_IV_SlaveDummy_poly_malaria = ((Z_short'/OMEGA)*Z_short)\((Z_short'/OMEGA)*X_short(:,2));

                    eps = X_short(:,2) - Z_short*betas_1st_RE_IV_SlaveDummy_poly_malaria;
                    eps_2 = eps.*eps;
                    e_e = eps*eps';
                    
                    AV1 = ((Z_short'/OMEGA)*Z_short)\(Z_short'/OMEGA);
                    
                    Avar_betas_1st_RE_IV_SlaveDummy_poly_malaria = (obs_short/(obs_short-size(Z_short,2)))*AV1*(e_e.*L)*AV1';           
              
                    std_betas_1st_RE_IV_SlaveDummy_poly_malaria = sqrt(diag(Avar_betas_1st_RE_IV_SlaveDummy_poly_malaria));  
                    
                    R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
                    Rsq(1,12)= R_sq;


















